import { world, MinecraftEffectTypes, system, Vector } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui"

const menu_normal = new ActionFormData()
    .title('Dino')
    .body('For updates, spoilers test and betas: \n- https://discord.gg/hCudpfDhW8 \n\nThanks for play!')
    .button('§1Follow Me', 'textures/menu/follow.png') // 0
    .button('§2Sit', 'textures/menu/sit.png') // 1
    .button('§1Wander', 'textures/menu/wander.png') // 2
    .button('§0Release Dino', 'textures/menu/release.png') // 3
    .button('§1Pasive', 'textures/menu/pasive.png') // 4
    .button('§0Neutral', 'textures/menu/neutral.png') // 5
    .button('§4Agresive', 'textures/menu/aggresive.png') // 6

const menu_volador = new ActionFormData()
    .title('Dino')
    .body('For updates, spoilers test and betas: \n- https://discord.gg/hCudpfDhW8 \n\nThanks for play!')
    .button('§1Follow Me') // 0
    .button('§2Sit') // 1
    .button('§1Wander') // 2
    .button('§0Fly Fix') // 3
    .button('§1Pasive') // 4
    .button('§0Neutral') // 5
    .button('§4Agresive') // 6

system.events.beforeWatchdogTerminate.subscribe(data => {
    data.cancel = true;
});

system.runInterval(async evd => {
    for (const entity of world.getDimension('overworld').getEntities()) {
        const ids = ['arkcraft', 'ark'];
        for (const dinosid of ids) {
            if (entity.typeId.includes(dinosid)) {
                entity.addEffect(MinecraftEffectTypes.regeneration, 200, 0, false);
            }
        }
        const ids2 = ['mc_ark', 'ananga'];
        for (const dinosid2 of ids2) {
            if (entity.typeId.includes(dinosid2)) {
                entity.addEffect(MinecraftEffectTypes.wither, 200, 200, false);
            }
        }
    }
}, 100);

system.runInterval(async evd => {
    for (const player of world.getPlayers()) {
        await player.runCommandAsync(`function desierto`)
        const inv = player.getComponent('inventory').container;
        const item = inv.getItem(player.selectedSlot);
        const { x, y, z } = player.location;
        if (player.hasTag('is_mounting')) {
            try {
                const block = player.dimension.getBlock(new Vector(x, y + 2, z));
                const headLoc = player.getRotation();
                const radian = (headLoc.y + 90) * (Math.PI / 180);
                const direction = { x: Math.cos(radian), y: Math.sin(radian) };
                if (!block.typeId.includes("minecraft:air")) {
                    await player.runCommandAsync(`camera @s clear`)
                }
                else {
                    if (direction.x >= 0.5) {
                        await player.runCommandAsync(`camera @s set minecraft:free ease 0.25 linear pos ~-3 ~2 ~ rot ~ ~`);
                    } else if (direction.x <= -0.5) {
                        await player.runCommandAsync(`camera @s set minecraft:free ease 0.25 linear pos ~3 ~2 ~ rot ~ ~`);
                    } else if (direction.y >= 0.5) {
                        await player.runCommandAsync(`camera @s set minecraft:free ease 0.25 linear pos ~ ~2 ~-3 rot ~ ~`);
                    } else if (direction.y <= -0.5) {
                        await player.runCommandAsync(`camera @s set minecraft:free ease 0.25 linear pos ~ ~2 ~3 rot ~ ~`);
                    }
                }
            } catch (e) { console.warn(e) }
        }
        else {
            player.runCommandAsync(`camera @s clear`)
        }
    }
}, 3);


//Dinos Menus

system.runInterval(async evd => {
    //code
    for (const player of world.getPlayers()) {
        //menu normal
        if (player.hasTag('menu_normal')) {
            player.removeTag('menu_normal')
            menu_normal.show(player).then(async result => {
                if (result.selection == 0) { //follow me
                    await player.runCommandAsync(`event entity @e[family=!wild,r=3,tag=in_modification] minecraft:seguir`)
                    await player.runCommandAsync(`playsound player_silbido @a[r=6]`)
                    await player.runCommandAsync(`tag @e[family=!wild,r=3,tag=in_modification] remove in_modification`)
                }
                if (result.selection == 1) { //sit
                    await player.runCommandAsync(`event entity @e[family=!wild,r=3,tag=in_modification] minecraft:quedarse_quieto`)
                    await player.runCommandAsync(`playsound player_silbido @a[r=6]`)
                    await player.runCommandAsync(`tag @e[family=!wild,r=3,tag=in_modification] remove in_modification`)
                }
                if (result.selection == 2) { //wander
                    await player.runCommandAsync(`event entity @e[family=!wild,r=3,tag=in_modification] minecraft:deambular`)
                    await player.runCommandAsync(`playsound player_silbido @a[r=6]`)
                    await player.runCommandAsync(`tag @e[family=!wild,r=3,tag=in_modification] remove in_modification`)
                }
                if (result.selection == 3) { //Release dino
                    await player.runCommandAsync(`event entity @e[family=!wild,r=3,tag=in_modification] minecraft:tamednt`)
                    await player.runCommandAsync(`playsound player_silbido @a[r=6]`)
                    await player.runCommandAsync(`tag @e[family=!wild,r=3,tag=in_modification] remove in_modification`)
                }
                if (result.selection == 4) { //Pacifico
                    await player.runCommandAsync(`event entity @e[family=!wild,r=3,tag=in_modification] minecraft:pacifico`)
                    await player.runCommandAsync(`playsound player_silbido @a[r=6]`)
                    await player.runCommandAsync(`tag @e[family=!wild,r=3,tag=in_modification] remove in_modification`)
                }
                if (result.selection == 5) { //Neutral
                    await player.runCommandAsync(`event entity @e[family=!wild,r=3,tag=in_modification] minecraft:neutral`)
                    await player.runCommandAsync(`playsound player_silbido @a[r=6]`)
                    await player.runCommandAsync(`tag @e[family=!wild,r=3,tag=in_modification] remove in_modification`)
                }
                if (result.selection == 6) { //Agresivo
                    await player.runCommandAsync(`event entity @e[family=!wild,r=3,tag=in_modification] minecraft:agresivo`)
                    await player.runCommandAsync(`playsound player_silbido @a[r=6]`)
                    await player.runCommandAsync(`tag @e[family=!wild,r=3,tag=in_modification] remove in_modification`)
                }
            });
        }
        //menu volador
        if (player.hasTag('menu_volador')) {
            player.removeTag('menu_volador')
            menu_volador.show(player).then(async result => {
                if (result.selection == 0) { //follow me
                    await player.runCommandAsync(`event entity @e[family=!wild,r=3,tag=in_modification] minecraft:seguir`)
                    await player.runCommandAsync(`playsound player_silbido @a[r=6]`)
                    await player.runCommandAsync(`tag @e[family=!wild,r=3,tag=in_modification] remove in_modification`)
                }
                if (result.selection == 1) { //sit
                    await player.runCommandAsync(`event entity @e[family=!wild,r=3,tag=in_modification] minecraft:quedarse_quieto`)
                    await player.runCommandAsync(`playsound player_silbido @a[r=6]`)
                    await player.runCommandAsync(`tag @e[family=!wild,r=3,tag=in_modification] remove in_modification`)
                }
                if (result.selection == 2) { //wander
                    await player.runCommandAsync(`event entity @e[family=!wild,r=3,tag=in_modification] minecraft:deambular`)
                    await player.runCommandAsync(`playsound player_silbido @a[r=6]`)
                    await player.runCommandAsync(`tag @e[family=!wild,r=3,tag=in_modification] remove in_modification`)
                }
                if (result.selection == 3) { //Release dino
                    await player.runCommandAsync(`event entity @e[family=!wild,r=3,tag=in_modification] minecraft:tamednt`)
                    await player.runCommandAsync(`playsound player_silbido @a[r=6]`)
                    await player.runCommandAsync(`tag @e[family=!wild,r=3,tag=in_modification] remove in_modification`)
                }
                if (result.selection == 4) { //Pacifico
                    await player.runCommandAsync(`event entity @e[family=!wild,r=3,tag=in_modification] minecraft:pacifico`)
                    await player.runCommandAsync(`playsound player_silbido @a[r=6]`)
                    await player.runCommandAsync(`tag @e[family=!wild,r=3,tag=in_modification] remove in_modification`)
                }
                if (result.selection == 5) { //Neutral
                    await player.runCommandAsync(`event entity @e[family=!wild,r=3,tag=in_modification] minecraft:neutral`)
                    await player.runCommandAsync(`playsound player_silbido @a[r=6]`)
                    await player.runCommandAsync(`tag @e[family=!wild,r=3,tag=in_modification] remove in_modification`)
                }
                if (result.selection == 6) { //Agresivo
                    await player.runCommandAsync(`event entity @e[family=!wild,r=3,tag=in_modification] minecraft:agresivo`)
                    await player.runCommandAsync(`playsound player_silbido @a[r=6]`)
                    await player.runCommandAsync(`tag @e[family=!wild,r=3,tag=in_modification] remove in_modification`)
                }
            });
        }
    }
});